jQuery(document).ready(function($) {
 
    // Listen for our change to our trigger type selectors
    jQuery('.requirements-list').on( 'change', '.select-trigger-type', function() {
        // Grab our selected trigger type and achievement selector
        var trigger_type = $(this).val();
        var score_input = $(this).siblings('.gb-percentage');
        var min_score_input = $(this).siblings('.gb-min-percentage');
        var max_score_input = $(this).siblings('.gb-max-percentage');

        // Toggle score field visibility
        if(
            trigger_type === 'gamipress_grassblade_content_with_min_per'
            || trigger_type === 'gamipress_grassblade_specific_content_with_min_per'
            || trigger_type === 'gamipress_grassblade_content_with_max_per'
            || trigger_type === 'gamipress_grassblade_specific_content_with_max_per'
        ) {
            score_input.show();
        } else {
            score_input.hide();
        }

        // Toggle min and max score fields visibility
        if(
            trigger_type === 'gamipress_grassblade_content_between_per'
            || trigger_type === 'gamipress_grassblade_specific_content_between_per'
        ) {
            min_score_input.show();
            max_score_input.show();
        } else {
            min_score_input.hide();
            max_score_input.hide();
        }

    });

    // Loop requirement list items to show/hide score input on initial load
    jQuery('.requirements-list li').each(function() {

        // Grab our selected trigger type and achievement selector
        var trigger_type = $(this).find('.select-trigger-type').val();
        var score_input = $(this).find('.gb-percentage');
        var min_score_input = $(this).find('.gb-min-percentage');
        var max_score_input = $(this).find('.gb-max-percentage');

        // Toggle score field visibility
        if(
            trigger_type === 'gamipress_grassblade_content_with_min_per'
            || trigger_type === 'gamipress_grassblade_specific_content_with_min_per'
            || trigger_type === 'gamipress_grassblade_content_with_max_per'
            || trigger_type === 'gamipress_grassblade_specific_content_with_max_per'
        ) {
            score_input.show();
        } else {
            score_input.hide();
        }

        // Toggle min and max score fields visibility
        if(
             trigger_type === 'gamipress_grassblade_content_between_per'
            || trigger_type === 'gamipress_grassblade_specific_content_between_per'
        ) {
            min_score_input.show();
            max_score_input.show();
        } else {
            min_score_input.hide();
            max_score_input.hide();
        }

    });

    jQuery('.requirements-list').on( 'update_requirement_data', '.requirement-row', function(e, requirement_details, requirement) {

        // Add score field
        if(
            requirement_details.trigger_type === 'gamipress_grassblade_content_with_min_per'
            || requirement_details.trigger_type === 'gamipress_grassblade_specific_content_with_min_per'
            || requirement_details.trigger_type === 'gamipress_grassblade_content_with_max_per'
            || requirement_details.trigger_type === 'gamipress_grassblade_specific_content_with_max_per'
        ) {
            requirement_details.gb_percentage = requirement.find( '.gb-percentage input' ).val();
        }

        // Add min and max score fields
        if(
            requirement_details.trigger_type === 'gamipress_grassblade_content_between_per'
            || requirement_details.trigger_type === 'gamipress_grassblade_specific_content_between_per'
        ) {
            requirement_details.gb_min_percentage = requirement.find( '.gb-min-percentage input' ).val();
            requirement_details.gb_max_percentage = requirement.find( '.gb-max-percentage input' ).val();
        }
    });

}); // end of ready