<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class grassblade_gamipress_achievement_report {
	function __construct()
	{
		add_filter("grassblade/reports/show_achievement_report", array($this, "show_achievement_report"), 10, 2);
		add_filter("grassblade/reports/achievement_options", array($this, "achievement_options"), 10, 1);
		add_filter("grassblade/reports/achievement_report/data", array($this, "achievement_report"), 10, 2);	
	}

	function show_achievement_report($r, $available_reports) {
		return true;
	}
	function achievement_options($achievement_options) {

		$achievement_post_types = gamipress_get_achievement_types();
		foreach($achievement_post_types as $achivement_post_type => $achivement_post_type_details) {
			$args = array(
				'numberposts' => -1,
				'post_type'   => $achivement_post_type, 
				);
			$achievements = get_posts($args);

			if(!empty($achievements))
			foreach($achievements as $achievement) {
				$achievement_options[$achievement->ID] =  $achivement_post_type_details["singular_name"] . ": " . $achievement->post_title;
			}
		}
		return $achievement_options;
	}
	function achievement_report($return, $params){
		global $wpdb;
	
		$user = empty($params['user']) ? null : $params['user'];    
		$request_achievements_id = empty($_POST["achievement_id"])? 0 : intVal($_POST["achievement_id"]);	
		$request_group_id = empty($params['group_id'])? 0 : intVal($params["group_id"]);
	
		$from 	= empty($params['from']) ? 0 :$params["from"];
		$to 	= empty($params['to']) ? 0 :$params["to"];

		$achievement_post_types = gamipress_get_achievement_types();
		$achievement_types = implode("','" , array_keys($achievement_post_types) );
		$sql = "SELECT user_id, post_id as achievement_id, points, post_type, date FROM {$wpdb->prefix}gamipress_user_earnings WHERE post_type IN('$achievement_types') ";
		
		if(!empty($user->ID)){
			$sql = $wpdb->prepare($sql . " AND user_id = %d", $user->ID);
		}

		if(!empty($request_achievements_id)) {
			$sql = $wpdb->prepare($sql . " AND  post_id = %d ", $request_achievements_id);
		}
			
		if(!empty($from) && !empty($to))	
		$sql = $wpdb->prepare($sql . " AND `date` >= '%s' AND `date` <= '%s'", wp_date("Y-m-d H:i:s", $from),  wp_date("Y-m-d H:i:s", $to)); //GamiPress db stores datetime in WordPress's timezone instead of UTC
		
		$sql = grassblade_add_group_user_query($sql, $request_group_id);
		$achievements_earned = $wpdb->get_results($sql); 

		if(empty($achievements_earned))
		return $return;

		if(empty($return["data"]) || !is_array($return["data"]))
		$return["data"] = array();
		
		$all_achievement_info = $all_get_achievement_steps = $all_achievement_image_url = array();

		foreach($achievements_earned as $achieved) {
			$achievement_id = $achieved->achievement_id;
			$user_info = get_userdata($achieved->user_id);
			$achievement_date = $achieved->date; //gb_datetime( strtotime( $achieved->date )); //GamiPress db stores datetime in WordPress's timezone instead of UTC

			if(!empty($all_achievement_info[$achievement_id]))
			$achievement_info = $all_achievement_info[$achievement_id];
			else
			$achievement_info = $all_achievement_info[$achievement_id] = get_post($achievement_id);

			if(!empty($all_get_achievement_steps[$achievement_id]))
			$get_achievement_steps = $all_get_achievement_steps[$achievement_id];
			else
			$get_achievement_steps = $all_get_achievement_steps[$achievement_id] = gamipress_get_achievement_steps($achievement_id);

			$step_titles = wp_list_pluck($get_achievement_steps, "post_title");
			if(count($step_titles) == 1)
			$achieved_for = $step_titles[0];
			else
			$achieved_for = "<ol><li>" . implode("</li><li>", $step_titles) . "</li></ol>";

			if(!empty($all_achievement_image_url[$achievement_id]))
			$achievement_image_url = $all_achievement_image_url[$achievement_id];
			else
			$achievement_image_url = $all_achievement_image_url[$achievement_id] = get_the_post_thumbnail_url($achievement_id,'thumbnail');

			$achievement_image_src = empty($achievement_image_url) ? "No Image Available" : "<img width = 50px src=".$achievement_image_url.">";

			$achievement_title = (!empty($achievement_post_types[$achieved->post_type])? $achievement_post_types[$achieved->post_type]["singular_name"] . ": " : "") . $achievement_info->post_title;

			$return["data"][] = [
				"sno" => 1,
				"achievement_date"	=> $achievement_date,
				"name"			=> gb_name_format( $user_info ),
				"user_id" 		=> $user_info->ID,
				"user_email" 	=> $user_info->user_email,
				"achivement_id" 	=> $achieved->achievement_id,
				"achievement_title"	=> wp_strip_all_tags( $achievement_title ),
				"achievement_image"	=> $achievement_image_src,
				"achievement_desc"	=> wp_strip_all_tags( $achievement_info->post_content ),
				"achieved_for" 	=> $achieved_for,
				"points_earned"	=> $achieved->points
			];
		}
		return $return;
	}
}
$grassblade_gamipress_achievement_report = new grassblade_gamipress_achievement_report();